#include "utils.PRO2"
#include "ArbreGen.hpp"
#include "ArbreGenIOint.hpp"

/* Pre: a=A , b = B  */
bool iguals(ArbreGen<int> &a, ArbreGen<int> &b){
  if (a.es_buit() and b.es_buit()) return true;
  if (a.es_buit() or b.es_buit()) return false;
  else {
    if (a.nombre_fills() != b.nombre_fills()) return false;
    if (a.arrel() != b.arrel()) return false;
    else{
      vector<ArbreGen<int> > va;
      vector<ArbreGen<int> > vb;
      a.fills(va);
      b.fills(vb);
      for (int i=0; i<va.size(); ++i){
	if (not iguals(va[i],vb[i])) return false;
      }
      return true;
    }
  }
}
// Post: retorna si A i B són iguals o no




int main() {
  ArbreGen<int> a; 
  llegir_arbreGen_int(a,0);
  //cout << endl << "2-llegir" << endl;
  ArbreGen<int> c(a);  
  //cout << "2-copia" << endl;
  escriure_arbreGen_int(c);
  cout << endl;
  ArbreGen<int> b;  
  llegir_arbreGen_int(b,0);
  //cout << endl;
  c=b;
  //cout << "3-llegir" << endl;
  escriure_arbreGen_int(c);
  cout << endl;
  if (iguals(a,b)) cout << "Són iguals" << endl;
  else cout << "No són iguals" << endl;
}
